techco-app/src/main/java/com/oracle/cloud/demo/oe/entities/OrderItem.java
package com.oracle.cloud.demo.oe.entities;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

@Entity
@Table(name = "ORDER_ITEMS")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "OrderItem.findAll", query = "SELECT o FROM OrderItem o"),
    @NamedQuery(name = "OrderItem.findByOrderId", query = "SELECT o FROM OrderItem o WHERE o.orderItemsPK.orderId = :orderId"),
    @NamedQuery(name = "OrderItem.findByOrderIdAndCustomerEmail", query = "SELECT o FROM OrderItem o WHERE o.orderItemsPK.orderId = :orderId and o.order.customer.custEmail = :customerEmail"),
    @NamedQuery(name = "OrderItem.findByLineItemId", query = "SELECT o FROM OrderItem o WHERE o.orderItemsPK.lineItemId = :lineItemId"),
    @NamedQuery(name = "OrderItem.findByUnitPrice", query = "SELECT o FROM OrderItem o WHERE o.unitPrice = :unitPrice"),
    @NamedQuery(name = "OrderItem.findByQuantity", query = "SELECT o FROM OrderItem o WHERE o.quantity = :quantity")})
public class OrderItem implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected OrderItemsPK orderItemsPK;
    // @Max(value=?)  @Min(value=?)//if you know range of your decimal fields consider using these annotations to enforce field validation
    @Column(name = "UNIT_PRICE")
    private BigDecimal unitPrice;
    @Column(name = "QUANTITY")
    private Integer quantity;
    @JoinColumn(name = "ORDER_ID", referencedColumnName = "ORDER_ID", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Order order;
    @JoinColumn(name = "PRODUCT_ID", referencedColumnName = "PRODUCT_ID")
    @ManyToOne(optional = false)
    private ProductInformation productId;

    public OrderItem() {
    }

    public OrderItem(OrderItemsPK orderItemsPK) {
        this.orderItemsPK = orderItemsPK;
    }

    public OrderItem(long orderId, short lineItemId) {
        this.orderItemsPK = new OrderItemsPK(orderId, lineItemId);
    }

    public OrderItem(Short lineItemId, Order order, ProductInformation productInfo, Integer quantity,
            BigDecimal unitPrice) {
        this(new OrderItemsPK(order.getOrderId(), lineItemId));
        this.order = order;
        this.productId = productInfo;
        this.quantity = quantity;
        this.unitPrice = unitPrice;
    }

    public OrderItemsPK getOrderItemsPK() {
        return orderItemsPK;
    }

    public void setOrderItemsPK(OrderItemsPK orderItemsPK) {
        this.orderItemsPK = orderItemsPK;
    }

    public BigDecimal getUnitPrice() {
        return unitPrice;
    }

    public void setUnitPrice(BigDecimal unitPrice) {
        this.unitPrice = unitPrice;
    }

    public Integer getQuantity() {
        return quantity;
    }

    public void setQuantity(Integer quantity) {
        this.quantity = quantity;
    }

    public Order getOrder() {
        return order;
    }

    public void setOrder(Order order) {
        this.order = order;
    }

    public ProductInformation getProductId() {
        return productId;
    }

    public void setProductId(ProductInformation productId) {
        this.productId = productId;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (orderItemsPK != null ? orderItemsPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof OrderItem)) {
            return false;
        }
        OrderItem other = (OrderItem) object;
        if ((this.orderItemsPK == null && other.orderItemsPK != null) || (this.orderItemsPK != null && !this.orderItemsPK.equals(other.orderItemsPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.oracle.samples.mavenproject2.OrderItems[ orderItemsPK=" + orderItemsPK + " ]";
    }

}

techco-app/src/main/java/com/oracle/cloud/demo/oe/web/OrderItemsController.java
package com.oracle.cloud.demo.oe.web;

import com.oracle.cloud.demo.oe.entities.OrderItem;
import com.oracle.cloud.demo.oe.entities.OrderItemsPK;
import com.oracle.cloud.demo.oe.sessions.OrderItemsFacadeRemote;
import com.oracle.cloud.demo.oe.web.util.JsfUtil;
import com.oracle.cloud.demo.oe.web.util.PaginationHelper;

import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.SelectItem;
import javax.inject.Named;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

@Named("orderItemsController")
@SessionScoped
public class OrderItemsController implements Serializable {
    private OrderItem current;
    private List<OrderItem> items;
    private PaginationHelper pagination;

    @EJB
    private OrderItemsFacadeRemote ejbFacade;

    public OrderItem getCurrent() {
        if (current == null) {
            current = new OrderItem();
            current.setOrderItemsPK(new OrderItemsPK());
        }
        return current;
    }

    public void setCurrent(OrderItem orderItem) {
        this.current = orderItem;
    }

    private OrderItemsFacadeRemote getFacade() {
        return ejbFacade;
    }

    public PaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new PaginationHelper(10) {
                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public List<OrderItem> createPageModel() {
                    return new ArrayList(getFacade().findRange(new int[]{getPageFirstItem(), getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public String prepareList() {
        recreateModel();
        return "List";
    }

    public String prepareView(OrderItem orderItem) {
        current = orderItem;
        return "View";
    }

    public String prepareCreate() {
        current = new OrderItem();
        current.setOrderItemsPK(new OrderItemsPK());
        return "Create";
    }

    public String create() {
        try {
            current.getOrderItemsPK().setOrderId(current.getOrder().getOrderId());
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("OrderItemsCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String prepareEdit(OrderItem orderItem) {
        current = orderItem;
        return "Edit";
    }

    public String update() {
        try {
            current.getOrderItemsPK().setOrderId(current.getOrder().getOrderId());
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("OrderItemsUpdated"));
            return "View";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String destroy(OrderItem orderItem) {
        current = orderItem;
        performDestroy();
        if (getItems().size() <= 1) {
            pagination.previousPage();
        }
        recreateModel();
        return "List";
    }

    public String destroy() {
        return destroy(current);
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("OrderItemsDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
        }
    }

    public List<OrderItem> getItems() {
        if (items == null) {
            items = getPagination().createPageModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    private void recreatePagination() {
        pagination = null;
    }

    public String next() {
        getPagination().nextPage();
        recreateModel();
        return "List";
    }

    public String previous() {
        getPagination().previousPage();
        recreateModel();
        return "List";
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), true);
    }

    public OrderItem getOrderItem(OrderItemsPK id) {
        return ejbFacade.find(id);
    }

    @FacesConverter(forClass = OrderItem.class)
    public static class OrderItemsControllerConverter implements Converter {
        private static final String SEPARATOR = "#";
        private static final String SEPARATOR_ESCAPED = "\\#";

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            OrderItemsController controller = (OrderItemsController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "orderItemsController");
            return controller.getOrderItem(getKey(value));
        }

        OrderItemsPK getKey(String value) {
            OrderItemsPK key = new OrderItemsPK();
            String values[] = value.split(SEPARATOR_ESCAPED);
            key.setOrderId(Long.parseLong(values[0]));
            key.setLineItemId(Short.parseShort(values[1]));
            return key;
        }

        String getStringKey(OrderItemsPK value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value.getOrderId());
            sb.append(SEPARATOR);
            sb.append(value.getLineItemId());
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof OrderItem) {
                OrderItem o = (OrderItem) object;
                return getStringKey(o.getOrderItemsPK());
            } else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + OrderItem.class.getName());
            }
        }
    }
}

techco-app/src/main/webapp/admin/orderItems/Create.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core">

    <ui:composition template="/templates/admin.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.CreateOrderItemsTitle}"></h:outputText>
        </ui:define>
        <ui:define name="content">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.CreateOrderItemsLabel_orderItemsPK_lineItemId}" for="orderItemsPK_lineItemId" />
                    <h:inputText id="orderItemsPK_lineItemId" value="#{orderItemsController.current.orderItemsPK.lineItemId}" title="#{bundle.CreateOrderItemsTitle_orderItemsPK_lineItemId}" required="true" requiredMessage="#{bundle.CreateOrderItemsRequiredMessage_orderItemsPK_lineItemId}"/>
                    <h:outputLabel value="#{bundle.CreateOrderItemsLabel_unitPrice}" for="unitPrice" />
                    <h:inputText id="unitPrice" value="#{orderItemsController.current.unitPrice}" title="#{bundle.CreateOrderItemsTitle_unitPrice}" />
                    <h:outputLabel value="#{bundle.CreateOrderItemsLabel_quantity}" for="quantity" />
                    <h:inputText id="quantity" value="#{orderItemsController.current.quantity}" title="#{bundle.CreateOrderItemsTitle_quantity}" />
                    <h:outputLabel value="#{bundle.CreateOrderItemsLabel_orders}" for="orders" />
                    <h:selectOneMenu id="orders" value="#{orderItemsController.current.order}" title="#{bundle.CreateOrderItemsTitle_orders}" required="true" requiredMessage="#{bundle.CreateOrderItemsRequiredMessage_orders}">
                        <f:selectItems value="#{ordersController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                    <h:outputLabel value="#{bundle.CreateOrderItemsLabel_productId}" for="productId" />
                    <h:selectOneMenu id="productId" value="#{orderItemsController.current.productId}" title="#{bundle.CreateOrderItemsTitle_productId}" required="true" requiredMessage="#{bundle.CreateOrderItemsRequiredMessage_productId}">
                        <f:selectItems value="#{productInformationController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{orderItemsController.create}" value="#{bundle.CreateOrderItemsSaveLink}" />
                |
                <h:commandLink action="#{orderItemsController.prepareList}" value="#{bundle.CreateOrderItemsShowAllLink}" immediate="true"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

techco-app/src/main/webapp/admin/orderItems/Edit.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core">

    <ui:composition template="/templates/admin.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.EditOrderItemsTitle}"></h:outputText>
        </ui:define>
        <ui:define name="content">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.EditOrderItemsLabel_orderItemsPK_lineItemId}" for="orderItemsPK_lineItemId" />
                    <h:inputText id="orderItemsPK_lineItemId" value="#{orderItemsController.current.orderItemsPK.lineItemId}" title="#{bundle.EditOrderItemsTitle_orderItemsPK_lineItemId}" required="true" requiredMessage="#{bundle.EditOrderItemsRequiredMessage_orderItemsPK_lineItemId}"/>
                    <h:outputLabel value="#{bundle.EditOrderItemsLabel_unitPrice}" for="unitPrice" />
                    <h:inputText id="unitPrice" value="#{orderItemsController.current.unitPrice}" title="#{bundle.EditOrderItemsTitle_unitPrice}" />
                    <h:outputLabel value="#{bundle.EditOrderItemsLabel_quantity}" for="quantity" />
                    <h:inputText id="quantity" value="#{orderItemsController.current.quantity}" title="#{bundle.EditOrderItemsTitle_quantity}" />
                    <h:outputLabel value="#{bundle.EditOrderItemsLabel_orders}" for="orders" />
                    <h:selectOneMenu id="orders" value="#{orderItemsController.current.order}" title="#{bundle.EditOrderItemsTitle_orders}" required="true" requiredMessage="#{bundle.EditOrderItemsRequiredMessage_orders}">
                        <f:selectItems value="#{ordersController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                    <h:outputLabel value="#{bundle.EditOrderItemsLabel_productId}" for="productId" />
                    <h:selectOneMenu id="productId" value="#{orderItemsController.current.productId}" title="#{bundle.EditOrderItemsTitle_productId}" required="true" requiredMessage="#{bundle.EditOrderItemsRequiredMessage_productId}">
                        <f:selectItems value="#{productInformationController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{orderItemsController.update}" value="#{bundle.EditOrderItemsSaveLink}"/>
                |
                <h:link outcome="View" value="#{bundle.EditOrderItemsViewLink}"/>
                |
                <h:commandLink action="#{orderItemsController.prepareList}" value="#{bundle.EditOrderItemsShowAllLink}" immediate="true"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

techco-app/src/main/webapp/admin/orderItems/List.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:fn="http://java.sun.com/jsp/jstl/functions">

    <ui:composition template="/templates/admin.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ListOrderItemsTitle}"></h:outputText>
        </ui:define>
        <ui:define name="content">
            <h:form styleClass="jsfcrud_list_form">
                <h:panelGroup id="messagePanel" layout="block">
                    <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
                </h:panelGroup>
                <h:panelGroup layout="block" styleClass="row" rendered="#{fn:length(orderItemsController.items) == 0}">
                    <h:outputText escape="false" value="#{bundle.ListOrderItemsEmpty}"/>
                </h:panelGroup>
                <h:panelGroup rendered="#{fn:length(orderItemsController.items) > 0}">
                    <ui:include src="/shared/pagination.xhtml">
                        <ui:param name="controller" value="#{orderItemsController}" />
                    </ui:include>
                    <h:dataTable value="#{orderItemsController.items}" var="item" styleClass="carttable">
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListOrderItemsTitle_orderItemsPK_lineItemId}"/>
                            </f:facet>
                            <h:outputText value="#{item.orderItemsPK.lineItemId}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListOrderItemsTitle_unitPrice}"/>
                            </f:facet>
                            <h:outputText value="#{item.unitPrice}">
                                <f:convertNumber locale="en-US" type="currency"/>
                            </h:outputText>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListOrderItemsTitle_quantity}"/>
                            </f:facet>
                            <h:outputText value="#{item.quantity}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListOrderItemsTitle_orders}"/>
                            </f:facet>
                            <h:outputText value="#{item.order}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListOrderItemsTitle_productId}"/>
                            </f:facet>
                            <h:outputText value="#{item.productId}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="&nbsp;"/>
                            </f:facet>
                            <h:commandLink action="#{orderItemsController.prepareView(item)}" value="#{bundle.ListOrderItemsViewLink}"/>
                            <h:outputText value="&nbsp;&nbsp;"/>
                            <h:commandLink action="#{orderItemsController.prepareEdit(item)}" value="#{bundle.ListOrderItemsEditLink}"/>
                            <h:outputText value="&nbsp;&nbsp;"/>
                            <h:commandLink action="#{orderItemsController.destroy(item)}" value="#{bundle.ListOrderItemsDestroyLink}"/>
                        </h:column>
                    </h:dataTable>
                </h:panelGroup>
                <h:commandLink action="#{orderItemsController.prepareCreate}" value="#{bundle.ListOrderItemsCreateLink}"/>
                <br />
                <h:link outcome="/admin/index" value="#{bundle.ListOrderItemsIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

techco-app/src/main/webapp/admin/orderItems/View.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html">

    <ui:composition template="/templates/admin.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ViewOrderItemsTitle}"></h:outputText>
        </ui:define>
        <ui:define name="content">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputText value="#{bundle.ViewOrderItemsLabel_orderItemsPK_lineItemId}"/>
                    <h:outputText value="#{orderItemsController.current.orderItemsPK.lineItemId}" title="#{bundle.ViewOrderItemsTitle_orderItemsPK_lineItemId}"/>
                    <h:outputText value="#{bundle.ViewOrderItemsLabel_unitPrice}"/>
                    <h:outputText value="#{orderItemsController.current.unitPrice}" title="#{bundle.ViewOrderItemsTitle_unitPrice}"/>
                    <h:outputText value="#{bundle.ViewOrderItemsLabel_quantity}"/>
                    <h:outputText value="#{orderItemsController.current.quantity}" title="#{bundle.ViewOrderItemsTitle_quantity}"/>
                    <h:outputText value="#{bundle.ViewOrderItemsLabel_orders}"/>
                    <h:outputText value="#{orderItemsController.current.order}" title="#{bundle.ViewOrderItemsTitle_orders}"/>
                    <h:outputText value="#{bundle.ViewOrderItemsLabel_productId}"/>
                    <h:outputText value="#{orderItemsController.current.productId}" title="#{bundle.ViewOrderItemsTitle_productId}"/>
                </h:panelGrid>
                <br />
                <h:link outcome="Edit" value="#{bundle.ViewOrderItemsEditLink}"/>
                |
                <h:commandLink action="#{orderItemsController.destroy}" value="#{bundle.ViewOrderItemsDestroyLink}"/>
                |
                <h:commandLink action="#{orderItemsController.prepareCreate}" value="#{bundle.ViewOrderItemsCreateLink}" />
                |
                <h:commandLink action="#{orderItemsController.prepareList}" value="#{bundle.ViewOrderItemsShowAllLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>